import { KMap, ModelType } from '..';
import { CacheItem } from './cache-item.class';
import { SubscribeInterface } from './subscribe.interface';
export interface CacheInterface {
    changed: CacheItem;
    all(): KMap;
    get(key: string, def?: unknown): unknown;
    put(key: string, value: unknown): unknown;
    has(key: string): boolean;
    subscribe(key: string): SubscribeInterface;
    forget(key: string): void;
    /**
     * Like put, it just pushes new values to subscribers after the end.
     */
    publish(key: string, value: unknown): unknown;
}
export declare class CacheFactory {
    all(model: ModelType): KMap<any>;
    get(model: ModelType, key: string): unknown;
    put(model: ModelType, key: string, value: unknown): void;
    publish(model: ModelType, key: string, value: unknown): void;
    has(model: ModelType, key: string): boolean;
    subscribe(model: ModelType, key: string): SubscribeInterface;
    forget(model: ModelType, key: string): void;
    private createCacheItem;
    private getModelCache;
    make(model: ModelType): CacheInterface;
}
