export class DataFactory {
    make(model) {
        return new Proxy({}, {
            get: (target, key, receiver) => {
                key = `${key}`;
                if (key.endsWith('$')) {
                    // subscribe
                    key = key.substring(0, key.length - 1);
                    return model.getSubscribeItemFunc(key);
                }
                else {
                    return model.getItem(key);
                }
            },
            set: (target, key, value) => {
                throw new Error(`[Kurimudb] Like "${model.options.name}.data.${key} = ${JSON.stringify(value)}" cannot be used on the Async Model because of JavaScript limitations. Please use "await ${model.options.name}.setItem('${key}')"`);
                return false;
            },
            has: (target, key) => {
                throw new Error(`[Kurimudb] Like "'${key}' in ${model.options.name}.data" cannot be used on the Async Model because of JavaScript limitations. Please use "await ${model.options.name}.has('${key}')"`);
                return false;
            },
            deleteProperty: (target, key) => {
                throw new Error(`[Kurimudb] Like "delete ${model.options.name}.data.${key}" cannot be used on the Async Model because of JavaScript limitations. Please use "await ${model.options.name}.removeItem('${key}')"`);
                return false;
            },
        });
    }
}
//# sourceMappingURL=data-factory.class.js.map