import { SyncAbstractDriverInterface } from '../../drivers/sync-abstract-driver.class';
import { SubscribeInterface } from '../../cache/subscribe.interface';
import { BaseModel } from '../../models/sync/base-model.class';
export declare type DataKeysType<Origin extends Record<string, any>> = {
    [Key in string & keyof Origin]: Key | `${Key}$`;
}[string & keyof Origin];
export declare type DataProxyType<Origin extends Record<string, any>> = {
    [Key in DataKeysType<Origin>]: Key extends `${string}$` ? SubscribeInterface : Origin[Key];
};
export declare class DataFactory {
    make<DataType, DriverType extends SyncAbstractDriverInterface | undefined>(model: BaseModel<DataType, DriverType>): DataProxyType<DataType>;
}
