var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { BaseModel } from "./base-model.class";
export class KeyValueModel extends BaseModel {
    constructor(options) {
        super(Object.assign(Object.assign({}, options), { ioType: "async", modelType: "keyValue" }));
        this.seeded = false;
    }
    seed(seed) {
        return __awaiter(this, void 0, void 0, function* () {
            let seedFunc;
            if ("function" === typeof seed) {
                seedFunc = () => __awaiter(this, void 0, void 0, function* () {
                    this.seeded = true;
                    yield seed();
                });
            }
            else if ("object" === typeof seed && !(seed instanceof Array)) {
                seedFunc = () => __awaiter(this, void 0, void 0, function* () {
                    this.seeded = true;
                    for (const key in seed)
                        yield this.setItem(key, seed[key]);
                });
            }
            else {
                throw new Error(`[Kurimudb] In "keyValue" model, the argument to the seed function must be "Function" or "Object".`);
            }
            if (this.seeded)
                return;
            if (undefined === this.storage) {
                yield seedFunc();
                return;
            }
            const storage = this.storage;
            yield storage.seeding(seedFunc);
        });
    }
}
//# sourceMappingURL=key-value-model.class.js.map